//+------------------------------------------------------------------------------------------+//
//|  CODE BASE  CODE BASE  CODE BASE  CODE BASE  CODE BASE  CODE BASE  CODE BASE  CODE BASE  |//
//+------------------------------------------------------------------------------------------+//
//+--------------------------------------------------------------------------------------------+
//PARAMETR TO SET//
extern string    Set_01             = "||------------------Close orders set-------------------||";
extern bool      Use_AutoClose      = false;    //Use autoclose logic
extern int       ProfitPercent      = 0;        //Profit percent to close orders
extern int       MaxOpenTime        = 0;        //Bars to maximum in opened each order
extern string    Set_02             = "||-----------------Modify orders set-------------------||";
extern bool      Use_Modify         = false;    //Modify stop loss in order
extern int       TypeModify         = 1;        //1:trailing stop, 2:break even
extern int       TrailingPoint      = 0;        //Point to move stop loss or put break even
extern int       ProfitBreakEven    = 0;        //Profit in point break even          
extern string    Set_03             = "||---------------------General set---------------------||";
extern bool      UseSound           = false;    //Play sound every to opening and closing orders
//////////////////////////////////////////////////////////////////////////////////////////////////
  string SoundClose="Alert2.wav";
  string SoundTimeOut="timeout.wav";
//+-----------------------------------------------------------------------------------------------------+
  int init()
  {
  return(0);
  }
//+-----------------------------------------------------------------------------------------------------+
  int deinit()
  {
  return(0);
  }
//+-----------------------------------------------------------------------------------------------------+
//+///CODE BASE START///////////////////////////////////////////////////////////////////////////////////+ 
//+-----------------------------------------------------------------------------------------------------+
  int start()
  {
//+-----------------------------------------------------------------------------------------------------+
//DIGITS PART//
  int MYpoint=1;
  ////////////////////////////////////
  if(Digits==5||Digits==3)
  {
  MYpoint=10;
  }
//+-----------------------------------------------------------------------------------------------------+
//MANAGEMENT ORDERS PART//
  int SumOrdersTotal;
  int MyOrders=0;
//+-----------------------------------------------------------------------------------------------------+
//MODIFY ORDERS PART//
  if(Use_Modify==true)
  {
  if(OrdersTotal()>0)
  {
  for(int cnt9=0;cnt9<OrdersTotal();cnt9++)
  {
  OrderSelect(cnt9,SELECT_BY_POS,MODE_TRADES);
  {
  switch(TypeModify)
  {
  case 1://Trailing stop loss
  if((OrderType()==OP_BUY)&&
  (OrderStopLoss()<NormalizeDouble(Ask-((TrailingPoint*Point)*MYpoint),Digits)))
  OrderModify(OrderTicket(),0,NormalizeDouble(Ask-((TrailingPoint*Point)*MYpoint),Digits),OrderTakeProfit(),0,Blue);
  if((OrderType()==OP_SELL)&&
  (OrderStopLoss()>NormalizeDouble(Ask+((TrailingPoint*Point)*MYpoint),Digits)))
  OrderModify(OrderTicket(),0,NormalizeDouble(Ask+((TrailingPoint*Point)*MYpoint),Digits),OrderTakeProfit(),0,Red);
  break;
  case 2://Break even
  if(ProfitBreakEven>TrailingPoint) ProfitBreakEven=TrailingPoint;
  if((OrderType()==OP_BUY)&&
  (NormalizeDouble((Ask-((((TrailingPoint)*Point)*MYpoint))),Digits)>OrderOpenPrice())&&
  (OrderStopLoss()!=NormalizeDouble(OrderOpenPrice()+(((ProfitBreakEven*Point)*MYpoint)),Digits)))
  OrderModify(OrderTicket(),0,NormalizeDouble(OrderOpenPrice()+(((ProfitBreakEven*Point)*MYpoint)),Digits),OrderTakeProfit(),0,Blue);
  if((OrderType()==OP_SELL)&&
  (NormalizeDouble((Ask+((((TrailingPoint)*Point)*MYpoint))),Digits)<OrderOpenPrice())&&
  (OrderStopLoss()!=NormalizeDouble(OrderOpenPrice()-(((ProfitBreakEven*Point)*MYpoint)),Digits)))
  OrderModify(OrderTicket(),0,NormalizeDouble(OrderOpenPrice()-(((ProfitBreakEven*Point)*MYpoint)),Digits),OrderTakeProfit(),0,Red);
  break;
  }
  /////////////////////////////////////////////////////
  }
  }
  }
  /////////////////////////////////////////////////////
  }
//+-----------------------------------------------------------------------------------------------------+
//TIME OVER CLOSE ORDERS PART//
  if((MaxOpenTime>0)&&(OrdersTotal()>0))
  {
  ///////////////////////////////////////////////////
  int PeriodConvert;
  if(Period()==1) PeriodConvert=60;
  if(Period()==5) PeriodConvert=300;
  if(Period()==15) PeriodConvert=900;
  if(Period()==30) PeriodConvert=1800;
  if(Period()==60) PeriodConvert=3600;
  if(Period()==240) PeriodConvert=14400;
  if(Period()==1440) PeriodConvert=86400;
  ///////////////////////////////////////////////////
  for(int cnt002=0; cnt002<OrdersTotal(); cnt002++)
  {
  OrderSelect(cnt002,SELECT_BY_POS,MODE_TRADES);
  {
  if((TimeCurrent()-OrderOpenTime())/PeriodConvert>MaxOpenTime-1)
  {
  if(OrderType()==OP_BUY)
  {
  OrderClose(OrderTicket(),OrderLots(),Bid,3,Aquamarine);
  if(UseSound) PlaySound(SoundTimeOut);
  }
  if(OrderType()==OP_SELL)
  {
  OrderClose(OrderTicket(),OrderLots(),Ask,3,Coral);
  if(UseSound) PlaySound(SoundTimeOut);
  }
  }
  }
  }
  }
//+-----------------------------------------------------------------------------------------------------+
//CLOSE ORDERS PART//
  if(Use_AutoClose==true)
  {
  ///////////////////////////////////
  if(OrderProfit()>0+((ProfitPercent*AccountBalance())/100))
  {
  for(int cnt1=OrdersTotal()-1; cnt1>=0; cnt1--)
  {
  OrderSelect(cnt1,SELECT_BY_POS,MODE_TRADES);
  {
  if(OrderType()==OP_BUY)
  {
  OrderClose(OrderTicket(),OrderLots(),Bid,3,Aquamarine);
  if(UseSound) PlaySound(SoundClose);
  }
  if(OrderType()==OP_SELL)
  {
  OrderClose(OrderTicket(),OrderLots(),Ask,3,Coral);
  if(UseSound) PlaySound(SoundClose);
  }
  }
  }
  }
  /////////////////////////////////////////////////////////////////
  }
//+-----------------------------------------------------------------------------------------------------+
  return(0);
  }
//+-----------------------------------------------------------------------------------------------------+
//+///CODE BASE END/////////////////////////////////////////////////////////////////////////////////////+ 
//+-----------------------------------------------------------------------------------------------------+

